#include "jw_sys_timer.h"
#include "SWM221.h"
#include "jw_bsp_init.h"

// ȫֱڼ¼ϵͳеtick뼶
uint32_t m_getTick;

extern void Timer_TASK_50msFunc(void);
extern void Timer_TASK_100msFunc(void);
extern void Timer_TASK_200msFunc(void);
extern void Timer_TASK_500msFunc(void);
extern void Timer_TASK_1000msFunc(void);
extern void Timer_TASK_2000msFunc(void);

/* ָָͣ޲޷ֵĺ */
typedef void (*TaskFunType)(void);

/* ָ飬洢ĵַ */
static TaskFunType TaskFunPtr[TASKFUNNUMBER] = 
{
	&Timer_TASK_50msFunc,    /* 1: 50ms */
    &Timer_TASK_100msFunc,   /* 2: 100ms */
    &Timer_TASK_200msFunc,   /* 3: 200ms */
    &Timer_TASK_500msFunc,   /* 4: 500ms */
    &Timer_TASK_1000msFunc,  /* 5: 1000ms */
    &Timer_TASK_2000msFunc   /* 6: 2000ms */
};

/**
 * @brief 1msʱжϻص 
 * @note úÿ1msһΣڸ񴥷־ 
 */
void Timer_Task_1ms(void)
{
    // ̬¼ϵͳʼĺ 
    static uint16_t Counterms = 0;
    uint8_t i = 0;
    
    // ȫtick32λ 
    // ﵽ32λֵʱ㣬 
	if (m_getTick == 0xFFFFFFFF) 
	{
		m_getTick = 0;
	} 
	else 
	{
		m_getTick++;
	}
    
    // Ƿ񳬹ֵ 
    if(Counterms > TASKMAXCOUNTER)
    {
        Counterms = 0;  // ֵ 
    }
    else 
    {
        Counterms++;    //  
        
        // 񣬼ǷҪ 
        for(i = 0; i < TASKFUNNUMBER; i++)
        {
            // 鵱ǰֵǷĴ 
            if((Counterms % TimeArr[i].Period) == TimeArr[i].Remainder)
            {
                TaskFlag[i] = TRUE;  // 񴥷־ 
            }
        }
    }
}

/* ʱȺ */
void Timer_MainFun(void)
{
    uint8_t i = 0;
    
    /*  */
    for(i = 0; i < TASKFUNNUMBER; i++)
    {
        /* ־ǷΪTRUEҪִУ */
        if(TaskFlag[i] == TRUE)
        {
            /* ָǷЧ */
            if(TaskFunPtr[i] != NULL)
            {
                /* ִжӦ */
                TaskFunPtr[i]();
                
                /* ִɺ־ */
                TaskFlag[i] = FALSE;
            }
        }
    }
}

void Timer_TASK_50msFunc(void)
{

}


void Timer_TASK_100msFunc(void)
{

}

void Timer_TASK_200msFunc(void)
{

}

void Timer_TASK_500msFunc(void)
{

}

void Timer_TASK_1000msFunc(void)
{
//	LOG("tiimer	1000ms...\r\n");
}

void Timer_TASK_2000msFunc(void)
{

}
