#ifndef __SWM221_QEI_H__
#define __SWM221_QEI_H__

typedef struct {
	uint8_t  mode;					//QEI_MODE_X2QEI_MODE_X4
	uint16_t maxcnt;				//ֵ
	uint8_t  swapAB;				//1 AB
	uint8_t  intINDEXEn;			//⵽Indexжʹ
	uint8_t  intMATCHEn;			//POSCNTMAXCNTȣPOSCNTMAXCNTݼ0жʹ
	uint8_t  intCNTOVEn;			//Counter Overrunжʹ
	uint8_t  intERROREn;			//жʹ
} QEI_InitStructure;


#define QEI_MODE_X2			0
#define QEI_MODE_X4			1

#define QEI_IT_INDEX		(1 << 0)
#define QEI_IT_MATCH		(1 << 1)
#define QEI_IT_CNTOV		(1 << 2)
#define QEI_IT_ERROR		(1 << 3)


void QEI_Init(QEI_TypeDef * QEIx, QEI_InitStructure * initStruct);		//QEIʼ
void QEI_Start(QEI_TypeDef * QEIx);						//QEI
void QEI_Stop(QEI_TypeDef * QEIx);						//رQEI

uint32_t QEI_IndexLvl(QEI_TypeDef * QEIx);				//QEI Indexŵƽ
uint32_t QEI_CountDir(QEI_TypeDef * QEIx);				//QEI0 	1 

void QEI_IntEn(QEI_TypeDef * QEIx, uint32_t it);		//QEIжʹ
void QEI_IntDis(QEI_TypeDef * QEIx, uint32_t it);		//QEIжϹر
void QEI_IntClr(QEI_TypeDef * QEIx, uint32_t it);		//QEIжϱ־
uint32_t QEI_IntStat(QEI_TypeDef * QEIx, uint32_t it);	//QEIж״̬ѯ


#endif //__SWM221_QEI_H__
