/* SEGGER RTT ͷļ */
#include <stdlib.h>
#include <stdarg.h>
#include "SEGGER_RTT.h" 
#include "SEGGER_RTT_Conf.h"
#include "JW_RTT.h"
 
#define BUFFER_INDEX 0  // ĬʹRTT0 
extern int SEGGER_RTT_vprintf(unsigned BufferIndex, const char * sFormat, va_list * pParamList);
 
/**
  * @brief   ͨ־ӡ 
  * @param   sFormat: ʽַ 
  * @param   ...: ɱб 
  * @retval   
  */
void print_log(const char * sFormat, ...)
{	
	va_list ParamList;           // ɱб 
	va_start(ParamList, sFormat); // ʼɱ 
	SEGGER_RTT_vprintf(BUFFER_INDEX, sFormat, &ParamList); // RTTӡ 
	va_end(ParamList);           // ɱ 
}
 
/**
  * @brief   ʼSEGGER RTTӡʼϢ 
  * @param   string: Ҫӡĳʼַ 
  * @retval   
  */
void segger_rtt_init(char * string)
{
	SEGGER_RTT_Init();     // ʼRTTģ 
	print_log(string);     // ӡʼϢ 
}
 
/**
  * @brief   ǰ׺־ӡ(JWרøʽ)
  * @param   sFormat: ʽַ 
  * @param   ...: ɱб 
  * @retval   
  */
void jw_rtt_print_log(const char * sFormat, ...)
{	
	va_list ParamList;
	print_log("[JW_LOG]: --------->"); // ӡ̶ǰ׺ 
	
	va_start(ParamList, sFormat);      // ʼɱ 
	SEGGER_RTT_vprintf(BUFFER_INDEX, sFormat, &ParamList); // ӡʵ־ 
	va_end(ParamList);                 // ɱ 
}